﻿using ProjectSeaplane.Entities;
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Drawnings;
/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawingSeaplaneEqutables : IEqualityComparer<DrawingBasicSeaplane?>
{
    public bool Equals(DrawingBasicSeaplane? x, DrawingBasicSeaplane? y)
    {
        if (x == null || x.EntityBasicSeaplane == null)
        {
            return false;
        }
        if (y == null || y.EntityBasicSeaplane == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityBasicSeaplane.Speed != y.EntityBasicSeaplane.Speed)
        {
            return false;
        }
        if (x.EntityBasicSeaplane.Weight != y.EntityBasicSeaplane.Weight)
        {
            return false;
        }
        if (x.EntityBasicSeaplane.BodyColor != y.EntityBasicSeaplane.BodyColor)
        {
            return false;
        }
        if (x is EntitySeaplane && y is EntitySeaplane)
        {
            // TODO доделать логику сравнения дополнительных параметров
            EntitySeaplane _x = (EntitySeaplane)x.EntityBasicSeaplane;
            EntitySeaplane _y = (EntitySeaplane)x.EntityBasicSeaplane;
            if (_x.AdditionalColor != _y.AdditionalColor)
            {
                return false;
            }
            if (_x.Radar != _y.Radar)
            {
                return false;
            }
            if (_x.LandingGear != _y.LandingGear)
            {
                return false;
            }
        }
        return true;
    }
    public int GetHashCode([DisallowNull] DrawingBasicSeaplane? obj)
    {
        return obj.GetHashCode();
    }
}